#ifndef FLYSCROLLBAR_H
#define FLYSCROLLBAR_H

#include <QScrollBar>

#include <flyintegration_global.h>

class FLYINTEGRATION_EXPORT FlyScrollBar : public QScrollBar
{
    Q_OBJECT

    Q_PROPERTY(bool indicatorMode READ indicatorMode WRITE setIndicatorMode)
    Q_PROPERTY(int indicatorExtent READ indicatorExtent WRITE setIndicatorExtent)

public:
    explicit FlyScrollBar(QWidget *parent = 0);

    bool indicatorMode() const;
    void setIndicatorMode(bool enable);

    int indicatorExtent() const;
    void setIndicatorExtent(int extent);

    QSize sizeHint() const Q_DECL_OVERRIDE;
    bool event(QEvent *event) Q_DECL_OVERRIDE;

protected:
    void paintEvent(QPaintEvent *event) Q_DECL_OVERRIDE;

private:
    bool m_indicatorMode;
    int m_indicatorExtent;
};

#endif // FLYSCROLLBAR_H
