#ifndef FLYSPLITTER_H
#define FLYSPLITTER_H

#include <QSplitter>

#include <flyintegration_global.h>

class FLYINTEGRATION_EXPORT FlySplitter : public QSplitter
{
    Q_OBJECT

    Q_PROPERTY(bool thinHandleModeEnabled READ isThinHandleModeEnabled WRITE setThinHandleModeEnabled)

    friend class FlySplitterControl;

public:
    explicit FlySplitter(QWidget *parent = 0);
    explicit FlySplitter(Qt::Orientation orientation, QWidget * parent = 0);

    bool isThinHandleModeEnabled() const;
    void setThinHandleModeEnabled(bool enable);

protected:
    QSplitterHandle* createHandle() Q_DECL_OVERRIDE;

private:
    bool m_thinHandleMode;
};

class FlySplitterControl;

class FLYINTEGRATION_EXPORT FlySplitterHandle : public QSplitterHandle
{
    Q_OBJECT

    friend class FlySplitterControl;

public:
    FlySplitterHandle(Qt::Orientation o, FlySplitter *parent);
    ~FlySplitterHandle();
    FlySplitter* splitter() const;

    QSize sizeHint() const Q_DECL_OVERRIDE;

    bool isThinHandleModeEnabled() const;
    void setThinHandleModeEnabled(bool enabled);

private:
    FlySplitterControl* m_splitterControl;
    bool m_thinHandleMode;
};

#endif // FLYSPLITTER_H
